/*
 * keiro_b.c : DT̗
 *
 */
/*
        1       3       5
        a------c------e
      ^                
  0 `                  
      _                
        b------d------f
        2       4       6

         oH}

*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define NODE 7
#define SIZE 64

/* אڃXg */
const char adjacent[NODE][4] = {
  1,  2, -1, -1,    /* A */
  0,  2,  3, -1,    /* B */
  0,  1,  4, -1,    /* C */
  1,  4,  5, -1,    /* D */
  2,  3,  6, -1,    /* E */
  3, -1, -1, -1,    /* F */
  4, -1, -1, -1,    /* G */
};

/* Queue */
char path[SIZE][NODE];
char length[SIZE];

/* oH̕\ */
void print_path( int n, int goal )
{
  int i;
  int len = length[n];
  for( i = 0; i <= len; i++ ){
    printf("%c ", path[n][i] + 'A' );
  }
  printf("%c\n", goal + 'A' );
}

/* DT */
void search( int start, int goal )
{
  int wc = 1, rc = 0;
  /*  */
  path[0][0] = start; /* X^[gn_Zbg */
  length[0] = 0;
  while( rc < wc ){
    int len = length[rc];
    int node = path[rc][len];
    int i, n;
    for( i = 0; (n = adjacent[node][i]) != -1; i++ ){
      if( memchr( path[rc], n, len + 1 ) == NULL ){
	if( n == goal ){
	  /* S[ɓB */
	  print_path( rc, goal );
	} else {
	  /* oHi߂ */
	  memcpy( path[wc], path[rc], len + 1 );
	  path[wc][len + 1] = n;
	  length[wc] = len + 1;
	  wc++;
	}
      }
    }
    rc++;
  }
  printf("Ԑ %d \n", wc );
}

int main()
{
  search( 0, 6 );
  return 0;
}


/* end of file */

